numSteps = 0;  // [0,1,2]
trayHeight = 1.4;
clearance = 0.4;

standoffHeight = (trayHeight-numSteps*clearance)*25.4;

baseThickness = 2;
wallThickness = 2;
cornerRad = 2;
text1 = str(standoffHeight/25.4,"\"");
text2 = str("Subtr ", numSteps*clearance, "\"");  
text3 = str(numSteps*clearance,"\" to ",(numSteps+1)*clearance,"\""); 

textThickness = .6;
textHeight = 5;
textOffset = 3-.9*numSteps; 
//riserHeight = standoffHeight-[0, 1, 2, 3]*.4*25.4;

riserHeight = standoffHeight-baseThickness;
baseLength = max(60,2*riserHeight);
textOffsetAngle = atan(textOffset/riserHeight);

$fn=10;

translate([baseLength/2,textOffset+1.5,baseThickness+1])
linear_extrude(textThickness)
text(text2,font = "Liberations Sans:style=bold", size=textHeight ,halign="center",valign="center");

translate([baseLength/2*cos(60-textOffsetAngle),baseLength/2*sin(60-textOffsetAngle),baseThickness+1])
rotate([0,0,-120])
linear_extrude(textThickness)
text(text3,font = "Liberations Sans:style=bold", size=textHeight ,halign="center",valign="center");

translate([baseLength/2*(2-cos(60-textOffsetAngle)),baseLength/2*sin(60-textOffsetAngle),baseThickness+1])
rotate([0,0,120])
linear_extrude(textThickness)
text(text1,font = "Liberations Sans:style=bold", size=textHeight ,halign="center",valign="center");


difference()
{
    minkowski()
    {
        union()
        {
            linear_extrude(baseThickness)
            polygon([[0,0],[baseLength,0],[baseLength/2,sqrt(3)/2*baseLength]],[[0,1,2]],2);
        
            rotate([0,0,30])
            translate([0,wallThickness/2,baseThickness])
            rotate([90,0,0])
            linear_extrude(wallThickness)
            polygon([[0,0],[baseLength/sqrt(3),0],[baseLength/sqrt(3),standoffHeight]],[[0,1,2]],2);
        
            translate([baseLength,0,baseThickness])
            rotate([0,0,150])
            translate([0,wallThickness/2,0])
            rotate([90,0,0])
            linear_extrude(wallThickness)
            polygon([[0,0],[baseLength/sqrt(3),0],[baseLength/sqrt(3),standoffHeight]],[[0,1,2]],2);
        
            translate([baseLength/2,sqrt(3)/2*baseLength,baseThickness])
            rotate([0,0,-90])
            translate([0,wallThickness/2,0])
            rotate([90,0,0])
            linear_extrude(wallThickness)
            polygon([[0,0],[baseLength/sqrt(3),0],[baseLength/sqrt(3),standoffHeight]],[[0,1,2]],2);
        
        }
        sphere(r=1);
    }
    
    // Cut off the top to provide a flat resting point
    translate([0,0,standoffHeight])
    cube([baseLength,baseLength,5]);  
    
    // Round the edges of the base
    difference()  
    {
       translate([.5*baseLength,.5*baseLength,0])
       cube([2*baseLength,2*baseLength,10],true);
       minkowski()
        {
            linear_extrude(5)
            polygon([[0,0],[baseLength,0],[baseLength/2,sqrt(3)/2*baseLength]],[[0,1,2]],2);
            cylinder(r=1,h=5);
        }
    }
}